Bug 53006 - Autocorrection TWo INitial CApitals does not work because of bundled extensions problem
Summary: Autocorrection TWo INitial CApitals does not work because of bundled extensio...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Linguistic (show other bugs)
Version:
(earliest affected)
3.6.0.4 release
Hardware: Other All
: medium normal
Assignee: Stephan Bergmann
QA Contact:
URL:
Whiteboard: BSA target:3.6.1 target:3.7.0
Keywords:
: 50906 53216 53266 53285 53303 53343 53344 53381 53392 53396 53459 53461 53470 53619 53634 53645 53879 53988 54040 54196 54467 54468 54754 (view as bug list)
Depends on:
Blocks: 43489 mab3.6
  Show dependency treegraph
 
Reported: 2012-07-31 14:38 UTC by Helmut Leininger
Modified: 2012-09-24 07:03 UTC (History)
27 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Helmut Leininger 2012-07-31 14:38:37 UTC
Problem description: 
Autocorrection during input is enabled.
Options are set to correct two Uppercase Letters at the beginning of a word ("ZWei Großbuchstaben am WOrtanfang korrigieren". 

If a word is mistyped (beginning with two uppercase letters) this is not corrected after typing the first space. It is not corrected when the Autocorrection is launched manually, either.

Settings are the same as in LO 3.5.3 where this problem does not occur.

Platform (if different from the browser): 
              
Browser: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:14.0) Gecko/20100101 Firefox/14.0.1
Comment 1 Rainer Bielefeld Retired 2012-07-31 15:37:11 UTC
[Reproducible] with Server Installation of  "LibreOffice 3.6.0.4 rc  English UI/ German Locale [Build-ID:  932b512] on German WIN7 Home Premium (64bit) as a result of the "dictionaries not available because of damaged bundled extensions folder" Bug. 

@Helmut Leininger
What is with the other options, do they work?
What's with Spell Check, does that work?
Are dictionaries for Spell Check available? If not, does renaming of subfolder "bundled" under "Extensions" in User profile 
<https://wiki.documentfoundation.org/UserProfile#User_profile_location> heal the problem?
Comment 2 Helmut Leininger 2012-07-31 16:08:31 UTC
@Rainer Bielefeld

Spell check did not work at all.
Renaming/deleting the bundle directory cured the problem. Hasn't been a problem like that some releases ago ?

Regards
Comment 3 Rainer Bielefeld Retired 2012-07-31 16:52:52 UTC
@Helmut Leininger
Yes, but we still suffer from some user profile update vulnerabilities (AOOo the same). Unfortunately it's difficult to find the reasons for the problem. Can you please do a zip of old and new affected "bundled" folders? May be I find someone who will try to check the differences and will find out something concerning the reasons for the problems.
Comment 4 Helmut Leininger 2012-07-31 17:24:20 UTC
You may download the zipped directories from 
http://members.inode.at/helmut.leininger/bundled_dirs.zip

Directory bundled is the newly created directory, bundled.sav is the old (renamed) one.
Comment 6 Stephan Bergmann 2012-08-01 10:21:23 UTC
(In reply to comment #0)
> If a word is mistyped (beginning with two uppercase letters) this is not
> corrected after typing the first space.

Just to clarify:  What you observe is you open a new writer document, type "FOo" followed by a space, and the word is not changed to "Foo" (irrespective whether it would be flagged as incorrect with a wavy red line by the spellchecker), right?

(In reply to comment #1)
> [Reproducible] with Server Installation of  "LibreOffice 3.6.0.4 rc  English
> UI/ German Locale [Build-ID:  932b512] on German WIN7 Home Premium (64bit)

Indeed reproducable at least on a fresh German (i.e., all tabs at "Region and Language" set to "German (Germany)") Windows 7 (32bit):
- default installation of LibO_3.5.5_Win_x86_install_multi.msi
- start "LibreOffice 3.5", "Text Document", do the above test: fine, "File - Exit", "Discard"
- default installation (i.e., upgrade) of LibO_3.6.0.4_Win_x86_install_multi.msi
- start "LibreOffice 3.6", terminates due to bug 43989, so restart "LibreOffice 3.6", "Text Document", do the above test: remains as "FOo"

> as a
> result of the "dictionaries not available because of damaged bundled extensions
> folder" Bug.

Which bug do you mean exactly?
Comment 7 Rainer Bielefeld Retired 2012-08-01 10:51:18 UTC
(In reply to comment #6)

> Just to clarify:  What you observe is you open a new writer document, type
> "FOo" followed by a space, and the word is not changed to "Foo" (irrespective
> whether it would be flagged as incorrect with a wavy red line by the
> spellchecker), right?

Yes, correct!
 
> Which bug do you mean exactly?

Unfortunately I did not find the bug I remembered. 

For me this problem here is "somehow" connected to the "no dictionaries available" problem, what always is caused by a "/extenisons/bundled/" problem.
When I rename "bundled" folder, I will see the dictionaries and the "TWo INitial CApitals" corrector will work correctly.

I find relations to this "bundled issue" in
Bug 50825 - Spellcheck and AutoSpellCheck does not work
Bug 51348 - English spellchecker doesn't work, or not installed
Bug 37439 - Dictionary access lost
Bug 38546 - No available language modules , spell check is impossible
Bug 50552 - SPELL check does not mark wrong text and capitalization rules
Bug 37195 - Dictionary access lost after LibO upgrade

But I can not contribute "the" Bug concerning this update issue.
Comment 8 Stephan Bergmann 2012-08-01 14:35:13 UTC
(Btw, also reproducible in an en-US setting, not just a de one.)

Just found out that, at least in LO 3.6.0 and current master, whether or not the "Correct TWo INitial CApitals" AutoCorrect option actually works depends on whether or not there is dictionary support for the current language (i.e., whether there is an "ABC" hook in front of the selection at "Format - Character... - Font - Language" in writer).  (And whether or not that coupling between auto correction and dictionary support is also a bug is another question.)

That explains why, e.g. in an en-US locale, the auto correction does not work in an upgraded LO 3.6.0 when the UserInstallation's user/extensions/bundled/registry/com.sun.star.comp.deployment.configuration.PackageRegistryBackend/configmgr.ini's DATA setting contains an outdated URI to a non-existing $BUNDLED_EXTENSIONS_PREREG/registry/com.sun.star.comp.deployment.configuration.PackageRegistryBackend/luXXXXX.tmp/dictionaries.xcu corresponding to the share/extensions/dict-en/dictionaries.xcu from the old LO 3.5.5 installation.

And that the UserInstallation's user/extensions/bundled/registry/com.sun.star.comp.deployment.configuration.PackageRegistryBackend/configmgr.ini still contains outdated data about an extension instance bundled with LO 3.5.5 is probably due to that bundled extension not having changed its version from LO 3.5.5 to LO 3.6.0 (it is still 2011.12.05 for dict-en) and there being some error in the LO code base that suppresses regeneration of per-user data about bundled extensions when references from that data to files (in the installation's share/extensions and/or share/prereg) become stale.
Comment 9 Stephan Bergmann 2012-08-01 15:18:43 UTC
(In reply to comment #8)
> some
> error in the LO code base that suppresses regeneration of per-user data about
> bundled extensions when references from that data to files (in the
> installation's share/extensions and/or share/prereg) become stale.

This erroneous staleness can *only* happen with references to the installation's share/prereg/bundled/ tree (aka $BUNDLED_EXTENSIONS_PREREG) (modulo buggy bundled extensions that substantially change their content but fail to bump their version).  Assume that the new LO installation bundles the same version of an extension as the old LO installation.  In such a case, LO does not necessarily regenerate the per-user data about that extension (in the UserInstallation's user/extensions/bundled/ tree), which potentially affects references from that data to three regions:

- A reference to the installation's share/extensions/ tree (aka $BUNDLED_EXTENSIONS) will reference effectively the same file in the new installation that it referenced in the old installation (since the extension's version did not change), so is OK.

- A reference to the UserInstallation's user/extensions/bundled/ tree (aka $BUNDLED_EXTENSIONS_USER) itself will keep referencing the same file (as the extension's per-user data is not regenerated), which in turn will correspond to effectively the same file in the new installation's share/extensions/ tree that it corresponded to in the old installation's share/extensions/ tree (since the extension's version did not change), so is OK.

- Only a reference to the installation's share/prereg/bundled/ tree (aka $BUNDLED_EXTENSIONS_PREREG) will potentially go stale, as (a) those references contain volatile luXXXXX.tmp segments that potentially change whenever that tree is regenerated (even from identical data), and (b) the new LO installation potentially does not have that tree at all.
Comment 10 Not Assigned 2012-08-02 20:39:37 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=c247613d2f19b01702520d837e55529fd3c0b021&g=libreoffice-3-6

Related fdo#53006 Make CApitals correction work without dictionary


It will be available in LibreOffice 3.6.1.
Comment 11 Stephan Bergmann 2012-08-03 08:18:26 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=566bcf64ad9092ba6e55ba3de514226ae6b10c10

Related fdo#53006 Make CApitals correction work without dictionary
Comment 12 Stephan Bergmann 2012-08-03 08:19:25 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=81fd6b084b0f3c0eb5a97c77592f5ceb21d2dfb1

fdo#53006 Force reinstall of all bundled extensions on upgrade
Comment 13 Stephan Bergmann 2012-08-03 09:01:45 UTC
(In reply to comment #8)
> Just found out that, at least in LO 3.6.0 and current master, whether or not
> the "Correct TWo INitial CApitals" AutoCorrect option actually works depends on
> whether or not there is dictionary support for the current language (i.e.,
> whether there is an "ABC" hook in front of the selection at "Format -
> Character... - Font - Language" in writer).  (And whether or not that coupling
> between auto correction and dictionary support is also a bug is another
> question.)

That coupling was a bug of its own, now addressed for LO 3.6.1 and 3.7 with the fixes from comment 10 and comment 11.
Comment 14 Stephan Bergmann 2012-08-03 09:08:51 UTC
(In reply to comment #9)
> This erroneous staleness can *only* happen with references to the
> installation's share/prereg/bundled/ tree (aka $BUNDLED_EXTENSIONS_PREREG)

...but it can cause more problems than the broken CApitals AutoCorrect option from this bug's original description, see the "Various problems with bundled extensions" item at <https://wiki.documentfoundation.org/ReleaseNotes/3.6#Most_annoying_bugs> (as of current revision <https://wiki.documentfoundation.org/index.php?title=ReleaseNotes/3.6&oldid=53954>).  The fix from comment 12 fixes that for LO 3.7, and I intend to get that backported to LO 3.6.1, too.
Comment 15 Not Assigned 2012-08-09 12:40:08 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=6c6358a6822d3562b9b8c7668a7d60d6c644dfe8

Related fdo#53006: Do not instantiate service manager too early
Comment 16 Not Assigned 2012-08-09 12:40:28 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=5300f6f711c2167931d45248c1b72dbce3a7df38

fdo#53006: Remove user/extensions/bundled cache after upgrade
Comment 17 Stephan Bergmann 2012-08-09 12:52:49 UTC
(In reply to comment #14)
> The fix from comment 12 fixes that for LO 3.7, and I intend to get that
> backported to LO 3.6.1, too.

Afterwards, it had become clear that there are further problems.  When you continuously upgraded through different LO 3.5.x versions, it could happen that a UserInstallation's user/extensions/bundled cache accrued duplicate, conflicting information about certain bundled extensions (that got changed from active to passive UNO registration in one LO 3.5.x version, but inadvertently had their version numbers bumped only in a later LO 3.5.y version), apparently due to the mechanism how share/prereg/bundled data was copied over (so only affected platforms that made use of share/prereg/bundled, like Windows or SUSE, but not Fedora).

To work around all these problems in a safe way, the fixes from comment 15 and comment 16 now always remove the user/extensions/bundled cache completely after an upgrade.  I intend to get those fixes backported to LO 3.6.1.
Comment 18 Stephan Bergmann 2012-08-10 14:49:54 UTC
*** Bug 53343 has been marked as a duplicate of this bug. ***
Comment 19 Stephan Bergmann 2012-08-10 15:00:00 UTC
*** Bug 53303 has been marked as a duplicate of this bug. ***
Comment 20 Not Assigned 2012-08-10 15:08:15 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=006e90e29c6ca768e3a5d8d2a558a63b04817c4b&g=libreoffice-3-6

Related fdo#53006: Do not instantiate service manager too early


It will be available in LibreOffice 3.6.1.
Comment 21 Not Assigned 2012-08-10 15:08:34 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=fd75125424b3dda0e77076d5b1709224ec22a345&g=libreoffice-3-6

fdo#53006: Remove user/extensions/bundled cache after upgrade


It will be available in LibreOffice 3.6.1.
Comment 22 Stephan Bergmann 2012-08-10 15:10:07 UTC
*** Bug 53285 has been marked as a duplicate of this bug. ***
Comment 23 Stephan Bergmann 2012-08-10 15:20:58 UTC
*** Bug 53266 has been marked as a duplicate of this bug. ***
Comment 24 bfoman (inactive) 2012-08-10 16:20:58 UTC
*** Bug 53344 has been marked as a duplicate of this bug. ***
Comment 25 bfoman (inactive) 2012-08-10 16:22:20 UTC
*** Bug 53246 has been marked as a duplicate of this bug. ***
Comment 26 Not Assigned 2012-08-10 17:42:09 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=0ab5ce54c441b12ea6c12a2cedb9069f36cfd0f4

fdo#53006: Remove directories too, not just plain files
Comment 27 manj_k 2012-08-12 14:28:51 UTC
*** Bug 53381 has been marked as a duplicate of this bug. ***
Comment 28 manj_k 2012-08-12 14:38:59 UTC
*** Bug 53396 has been marked as a duplicate of this bug. ***
Comment 29 Not Assigned 2012-08-13 09:41:33 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8609e601b7351fd9480475e12e9e2c1aa7811c78&g=libreoffice-3-6

fdo#53006: Remove directories too, not just plain files


It will be available in LibreOffice 3.6.1.
Comment 30 Not Assigned 2012-08-13 15:55:04 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=e9631f40ee49a244b6c6816e5cfb36814b9bafba

fdo#53006: And detect LO downgrading scenarios...
Comment 31 Not Assigned 2012-08-13 16:47:00 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=aed059b816a1df35be33598916acf341dd1a31ac&g=libreoffice-3-6

fdo#53006: And detect LO downgrading scenarios...


It will be available in LibreOffice 3.6.1.
Comment 32 manj_k 2012-08-13 22:37:41 UTC
*** Bug 53461 has been marked as a duplicate of this bug. ***
Comment 33 manj_k 2012-08-13 22:40:21 UTC
*** Bug 53459 has been marked as a duplicate of this bug. ***
Comment 34 bfoman (inactive) 2012-08-14 09:31:24 UTC
*** Bug 53470 has been marked as a duplicate of this bug. ***
Comment 35 Dennis Anderson 2012-08-14 17:25:53 UTC
(In reply to comment #34)
> *** Bug 53470 has been marked as a duplicate of this bug. ***

I don't see much common symptoms in my total system install that immediately gives a real time error when attempting to load LO 3.6, I likely have something different in one of my computers, since it installed OK in my other two computers.

I fully uninstalled all of LO and still couldn't get the released 3.6 to load.  So, I've gone back to 3.5.
Comment 36 Stephan Bergmann 2012-08-16 06:44:36 UTC
*** Bug 53288 has been marked as a duplicate of this bug. ***
Comment 37 bfoman (inactive) 2012-08-17 20:33:37 UTC
*** Bug 53645 has been marked as a duplicate of this bug. ***
Comment 38 manj_k 2012-08-17 23:21:35 UTC
*** Bug 53619 has been marked as a duplicate of this bug. ***
Comment 39 Michael Meeks 2012-08-21 14:05:50 UTC
*** Bug 53879 has been marked as a duplicate of this bug. ***
Comment 40 bfoman (inactive) 2012-08-24 06:39:50 UTC
*** Bug 53988 has been marked as a duplicate of this bug. ***
Comment 41 manj_k 2012-08-24 10:29:39 UTC
*** Bug 53392 has been marked as a duplicate of this bug. ***
Comment 42 bfoman (inactive) 2012-08-29 09:22:27 UTC
*** Bug 54196 has been marked as a duplicate of this bug. ***
Comment 43 bfoman (inactive) 2012-09-04 11:24:30 UTC
*** Bug 54468 has been marked as a duplicate of this bug. ***
Comment 44 bfoman (inactive) 2012-09-04 11:25:08 UTC
*** Bug 54467 has been marked as a duplicate of this bug. ***
Comment 45 Rainer Bielefeld Retired 2012-09-18 05:29:26 UTC
*** Bug 53216 has been marked as a duplicate of this bug. ***
Comment 46 Rainer Bielefeld Retired 2012-09-18 05:30:43 UTC
*** Bug 54754 has been marked as a duplicate of this bug. ***
Comment 47 Rainer Bielefeld Retired 2012-09-18 05:31:33 UTC
*** Bug 54040 has been marked as a duplicate of this bug. ***
Comment 48 Rainer Bielefeld Retired 2012-09-18 05:32:04 UTC
*** Bug 53634 has been marked as a duplicate of this bug. ***
Comment 49 Roman Eisele 2012-09-24 07:03:02 UTC
*** Bug 50906 has been marked as a duplicate of this bug. ***